/*==============================================================================
		ファイルアクセスクラス	for ＢｅＯＳ		Ver 1.10
		Copyright (C) 1999 by ＳＨＩＮＴＡ
		Last Modified 1999.04.02
==============================================================================*/

/*==============================================================================
 Ver. |					主な改良点
--------------------------------------------------------------------------------
 ---- | 1999.02.19.Fr 開発着手。
 1.00 | 1999.02.20.Sa オリジナルバージョン。Eof()、ReadLine()、WriteLine()。
 1.10 | 1999.04.02.Fr ReadValidLine()を作った。
==============================================================================*/

/*=== Memo =====================================================================
==============================================================================*/

#include "SHIFile.h"
//------------------------------------------------------------------------------
bool	TSHIFile::Eof()
{
	off_t	xSize;
	
	GetSize(&xSize);
	return (Position() >= xSize);
}
//------------------------------------------------------------------------------
ssize_t	TSHIFile::ReadLine(char *szBuffer,ssize_t xMaxSize)
{
	ssize_t	iCount = 0;

	while ( iCount < xMaxSize-1 && !Eof() ) {
		Read(&szBuffer[iCount],1);
		if ( szBuffer[iCount] == '\n' )	break;
		iCount++;
	}
	szBuffer[iCount] = '\0';
	return iCount;
}
//------------------------------------------------------------------------------
ssize_t	TSHIFile::ReadValidLine(char *szBuffer,ssize_t xMaxSize)
{
	ssize_t	iCount;
	
	for ( ;; ) {
		if ( Eof() ) {
			iCount = 0;
			break;
		}
		iCount = ReadLine(szBuffer,xMaxSize);
		if ( szBuffer[0] != '\0' && szBuffer[0] != '/' && szBuffer[1] != '/' )
			break;
	}
	return iCount;
}
//------------------------------------------------------------------------------
ssize_t	TSHIFile::WriteLine(const char *szBuffer)
{
	ssize_t	xSize;
	
	xSize = Write(szBuffer,strlen(szBuffer));
	xSize += Write("\n",1);
	return xSize;
}
//------------------------------------------------------------------------------
